/* A card game where the player gets assigned spanks based on the deal of the cards. */

setInfos(4, "Game of Chance", "A spanking card game", "marspank", "complete", 0xFFFFFF, "en", ["spanking", "game"]);

//Configurable starting conditions
def jokerSpanks = 10
def noMatchSpanks = 2
def baseImplement="hairbrush"
def jokerImplement="bath brush"

def startSuit = -1
def startValue = -1
def matchSuit
def matchValue
def matchFound = false

def suitArray = ["Hearts","Diamonds","Spades","Clubs",""]
def faceArray = ["Ace","2","3","4","5","6","7","8","9","10","Jack","Queen","King",""]

def cardValue
def suit

def dealt = new boolean[56]
def shuffle = {
	for(i in 0..55)
	{
		dealt[i] = false
	}
	if(startSuit != -1)
	{
		dealt[startSuit*13+startValue] = true
	}
}
shuffle()

def respectTitle = "Miss"
if(loadBoolean("intro.likefemale"))
{
	respectTitle = "Miss"
}
else
{
	respectTitle = "Sir"
}
def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}

	if ( itemKeys.isEmpty() ) return null

	return itemKeys[ getRandom(itemKeys.size()) ]
}


def rulesDisplay = {
	show("This game of chance is bascially a card matching game."
		+"\nYou will be assigned a card, and you have to draw from the deck until you match it.")
	wait(10)
	show("The card you are assigned will be the top card of the deck after a shuffle."
		+"\n\nAnd the card you need to find to match it is the same face value."
		+"\nBut not just any suit, it has to be the same color as your card.")
	wait(10)
	show("And since the card you drew is taken out of the deck, "
		+"that means there is only 1 possible match for you to find left in the deck.")
	showButton("Only one "+respectTitle+"?")
	show("Correct, and every card you draw that is not the match will earn you "
		+noMatchSpanks+" swats")
	showButton("....")
	show("That isn't even the best part. Well, best part for me..")
	showButton("?")
	show("There are also 4 jokers in the deck")
	showButton("Jokers?")
	show("Yes, Jokers.\nWhenever you draw a joker, you get "+jokerSpanks+" swats")
	showButton("Ouch "+respectTitle)
	show("And I can't forget to mention that every time you draw a Joker...")
	wait(10)
	show("All the cards you have drawn (except your initial card) are shuffled back into the deck!")
	wait(10)
}
def drawNextCard = {
	cardValue = getRandom(14)
	suit = getRandom(4)
	while(dealt[suit*14+cardValue])
	{
		cardValue = getRandom(14)
		suit = getRandom(4)
	}
	dealt[suit*14+cardValue] = true
}
def x=0
def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(3)
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("swat.wav")
		wait(time)
	}
}

def gameRound = {
	while(!matchFound)
	{
		drawNextCard()
		//Card drawn is a joker
		if(cardValue == 13)
		{
			show("Oh no, you found a joker")
			wait(10)
			show("Time for your "+jokerImplement+" spanks")
			wait(10)
			spank("Spank your butt hard",jokerSpanks,1)
			show("And now I get to reshuffle the deck...")
			wait(25)
			shuffle()
			show("And draw your next card..")
			wait(5)
		}
		else if(cardValue == matchValue && suit == matchSuit)
		{
			matchFound = true
			show("You drew the "+faceArray[cardValue]+" of "+suitArray[suit])
			wait(10)
			show("Hey, lucky you, that is your match card. Hope it didn't take too long to find.")
			showButton("Thank you "+respectTitle)
		}
		else
		{
			show("You drew the "+faceArray[cardValue]+" of "+suitArray[suit])
			wait(10)
			dealt[suit*14+cardValue] = true
			show("That means "+noMatchSpanks+" more swats with the "+baseImplement)
			wait(5)
			spank("One hard swat on each cheek",noMatchSpanks,1)
			show("Drawing the next card")
			wait(5)
		}
	}
	
}

def imageSpeed = 20
def setImageFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)((width*it)/10), (int)((height*it)/10),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)((width*it)/10), (int)((height*it)/10), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
}
def setImageOffFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)(width/it), (int)(height/it),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)(width/it), (int)(height/it), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
	setImage(null)
}

//START OF SCRIPT
show("Time to play a Game of Chance")
if(loadBoolean("user.likefemale"))
{
	if(loadBoolean("mistress.active"))
	{
		setImage(loadString("mistress.folder")+"/"+loadString("mistress.name")
			+(getRandom(loadInteger("mistress.pictures"))+1)+".jpg")
	}
	else
	{
		setImage("default-female.jpg")
	}
}
else if(loadBoolean("user.likemale"))
{
	if(loadBoolean("master.active"))
		setImage(loadString("master.folder")+"/"+loadString("master.name")
			+(getRandom(loadInteger("master.pictures"))+1)+".jpg")
	else setImage("default-male.jpg")
}
wait(10)

if(getBoolean("Do you want to review the rules?","Yes","I know them"))
{
	rulesDisplay()
	while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
	{
		rulesDisplay()
	}
}
show("You will be using two different implements on your butt.\n\nOne for the normal cards,"
	+" and a more severe implement for the jokers")
wait(10)
if(getBoolean("Do you want to set the implements randomly based on what you have?\n\nOr do you want to input them?",
	"Randomly","Set them myself"))
{
	def implement = getRandomItem(["toys.hairbrush","toys.ruler","toys.spatula",
		"toys.wooden_spoon","toys.bathbrush","toys.slipper"])
	if(implement == "toys.hairbrush") baseImplement = "hairbrush"
	else if(implement == "toys.ruler") baseImplement = "ruler"
	else if(implement == "toys.spatula") baseImplement = "spatula"
	else if(implement == "toys.wooden_spoon") baseImplement = "wooden spoon"
	else if(implement == "toys.bathbrush") baseImplement = "bath brush"
	else if(implement == "toys.slipper") baseImplement = "slipper"

	if(implement == null)
	{
		baseImplement = getString("You don't have any of the implements I was looking for. \n\nEnter the one you want for normal cards", "")
	}
	
	implement = getRandomItem(["toys.paddle","toys.paddle_holes","toys.bathbrush","toys.strap"
		,"toys.belt","toys.cane","toys.crop"])
	if(implement == "toys.paddle") jokerImplement = "paddle"
	else if(implement == "toys.paddle_holes") jokerImplement = "paddle with holes"
	else if(implement == "toys.strap") jokerImplement = "strap"
	else if(implement == "toys.belt") jokerImplement = "belt"
	else if(implement == "toys.bathbrush") jokerImplement = "bath brush"
	else if(implement == "toys.cane") jokerImplement = "cane"
	else if(implement == "toys.crop") jokerImplement = "crop"

	if(implement == null)
	{
		jokerImplement = getString("You don't have any of the implements I was looking for. \n\nEnter the one you want for jokers", "")
	}

	show("The implements selected are:\n\nBase Implement: "+baseImplement
		+"\nJoker Implement: "+jokerImplement)
	showButton("Have them ready "+respectTitle)
}
else
{
		baseImplement = getString("Enter the implement you want for normal cards", "")
		jokerImplement = getString("Enter the implement you want for jokers", "")
}	
show("Since this game features almost continuous spanking, why don't you remove all your clothes"
	+", but leave your socks on, you look so pathetic and awkward like that")
showButton("Yes "+respectTitle)
show("Time to draw your starting card")
wait(5)
startSuit = getRandom(4)
startValue = getRandom(14)
while(startValue == 13)
{
	show("That is an unlucky start to the game, you drew a joker.")
	wait(10)
	show("Get those pants down and get out your "+jokerImplement+".")
	showButton("Ready "+respectTitle)
	spank("Hard swats only",jokerSpanks,1)
	show("Let's draw another card, hopefully not a joker")
	startValue = getRandom(14)
	wait(10)
}
dealt[startSuit*14 + startValue] = true
matchValue = startValue
if(startSuit == 0) matchSuit = 1
else if(startSuit == 1) matchSuit = 0
else if(startSuit == 2) matchSuit = 3
else matchSuit = 2

show("Your starting card is the "+faceArray[startValue]+" of "+suitArray[startSuit]
	+"\n\nWhich means the card you need to match is the "
	+faceArray[matchValue]+" of "+suitArray[matchSuit])
showButton("I will get it "+respectTitle)

gameRound()
	
show("Now wasn't that a fun game?"
	+"\nCome back soon so we can play it again.")
wait(10)
return null

/*
 * Resources
 * scripts/gameofchance.groovy
 */

// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
// (Author may change thoses lines)




